# Twine
A simple survival mod for Minecraft encouraging a nomadic lifestyle.

Created For [ModFest 1.16](https://modfest.net/1.16)

## Backpacks
A backpack can only hold one type of item or only hold unstackable items.

### Small Backpack Recipe
<table>
<tr><th>Stick</th><th>Leather</th><th>Stick</th></tr>
<tr><th>Leather</th><th>Iron Ingot</th><th>Leather</th></tr>
<tr><th>Stick</th><th>Leather</th><th>Stick</th></tr>
</table>

### Large Backpack Recipe
Combine a Small Backpack with a Gold Ingot in the Smithing Table.

### Dye Backpack Recipe
Combine a Backpack with a dye in the Crafting Table.

## Glowing Obsidian
Glowing Obsidian heals monsters and hurts everything else. It naturally generates in small patches underground.

### Recipe
<table>
<tr><th></th><th>Redstone</th><th></th></tr>
<tr><th>Redstone</th><th>Obsidian</th><th>Redstone</th></tr>
<tr><th></th><th>Redstone</th><th></th></tr>
</table>

## Chest Boats
Right-Click a Boat with a Chest to place it in the Boat, you can also use an Ender Chest. Shift-Right-Click the Boat to open the Chest. You can also open the Chest inside the Boat by opening your inventory.

## Difficulty Stages
Each player has a "personal" stage of an area, the highest online player's difficulty stage in an area will be the "effective" difficulty stage of that area.

### Stage 1
- Normal Gameplay

### Stage 2
- Hostile Mobs Attack Passive Mobs

### Stage 3
- Mobs Are Guaranteed To Have At Least One Piece Of Armor

### Stage 4
- Villages Kick You Out (Using Iron Golems)
- Creepers Target Artificial Blocks

### Stage 5
- Neutral Mobs Are Always Hostile

### Stage 6
- Mobs No Longer Burn In Sunlight

### Technical Details
Each player has a 6-element long list in their data. Each element in the list has a chunk position and time value. Every tick the player will first, find the stage element its current position is in, and increase the time value of that stage element. If the time value when increased is over 24,000 ticks the next stage element will have its chunk set to the players current position, have its time value reset, the old stage element will have the next stage element's old chunk, and have its time value reset. To determine if a player is in a stage element, it checks if the player is within 16 chunks of the stage element's chunk, it starts searching at the last element, ending at the first. The "effective" stage element of a chunk can be found by searching every **online** player for their stage element for the chunk and then picking the highest value.

## End Rods
Most hostile mobs are afraid of End Rods.

## Changelog
[View Changelog](CHANGELOG.md)

## Credits
Thanks to ```sirikaros``` for the backpack textures!